import * as Benchmark from "benchmark_core/benchmark";
/**
 * 基准测试入口文件
 */

declare var _$pi;

export const run = () => {
    console.log("开始执行基准测试");
    for (const [k, _] of _$pi._modules) {
        if (k.endsWith(".bench")) {
            import(k);
        }
    }
}


export function cycleLog(suite: Benchmark.Suite, bench: Benchmark) {
    // console.log(`${suite.name}`, String(bench));
    let period = bench.times.period;  // s
    let count = 3;
    while (count) {
        if (period >= 1) break;
        period *= 1000;
        count--;
    }
    const timeUnits = ["ns", "us", "ms", "s"]
    console.log(`${(<any>suite).name} ${bench.name} ${period.toFixed(3)}${timeUnits[count]} once excute ±${bench.stats.rme.toFixed(2)}% （${bench.stats.sample.length} runs sampled）`);
    const args = [(<any>suite).name, bench.name, `${period.toFixed(3)}${timeUnits[count]}`, Math.floor(bench.hz), `±${bench.stats.rme.toFixed(2)}%`, bench.stats.sample.length.toString()];
    createTr(args);
}


export function completeLog(suite: Benchmark.Suite) {
    console.log(`${(<any>suite).name} completed!!`);
}

const createTr = (args: string[]) => {
    const tr = document.createElement("div");
    tr.setAttribute("class", "tr");
    for (const str of args) {
        const td = document.createElement("div");
        td.setAttribute("class", "td");
        td.innerHTML = str;
        td.title = str;
        tr.appendChild(td);
    }
    const tbody = document.querySelector(".tbody");
    tbody.appendChild(tr);
}