(function () {
    var os = {
        mobile_asset_path: "dst",    // 仅APK-Webview版本有效，放到assets的资源目录是啥，如果匹配不上，则不会去读asset包；
    };
    winit.setOs(os);

    //#region 设置项目通用配置
    var project = {
        /**
         * @TODO !!!每个项目必须定义自己的名称，该名称决定了访问二级域名和本地存储名
         */
        name: 'pi_demo',
        app_id: "pi_demo",
        version_no: '1.0.4',
        // 全局错误捕捉，记录次数后发送到服务器上
        catch: true,
        debug: true,
    };

    winit.setProject(project);

    // 5 verbose, 4 debug, 3 info, 2 warn, 1 error, 0 none
    const logMaxLevel = project.debug ? 4 : 3;

    // 上传到日志服务器的 策略，项目自己调整；
    // 这里 默认策略：如果是release，则 上传日志到 http服务器；
    const isUploadHttp = !project.debug;

    let logger = {

        appenders: [{
            name: "console",
            kind: "ConsoleKind",
        },
        {
            name: "http",
            kind: "HttpKind",
            args: {
                url: "http://120.79.176.159:8111",
            }
        }
        ],

        meta: {
            project: "pi_demo", // 项目名
            channel: "default", // 渠道名
            version: "1.0.0",   // 版本
            process_id: performance.now().toString(),
        },

        root: { // 默认 target
            level: logMaxLevel,
            appenders: ["console"],
        },
        loggers: [],
    };


    if (isUploadHttp) {
        logger.root.appenders.push("http");
    }

    winit.setLogger(logger);

    //#endregion

    //#region 设置Gui相关配置
    var gui = {
        img_zoom: 1,
        design_size: {
            width: 750,
            height: 1334,
        },

        max_extend: 0.5,
        gpu_performance: 1, // 具体看文档； 
        rotate_fit: true,

        // 不填的情况下，底层自动根据game.version 和 当前平台的功能 共同决定用哪种格式的图片；
        // compressed_tex_formats: ["astc"], 

        img_zoom_options: [1.0],

        // 显示区域，该选项可选，默认为设备的安全区域
        // show_rect: {top: 0, left: 0, bottom:0, right: 0}, 
    };
    winit.setGui(gui);
    //#endregion

    //#region 设置加载资源相关配置
    var loadRes = {
        code_suffixs: // 代码的后缀
            [],
        cfg_suffixs: // 配置的后缀
            [
                'widcfg', 'dcss', 'kcss', 'imgcfg', 'jcfg'
            ],
        res_suffixs: // 资源的后缀
            [
                'wasm', 'rjson', 'atlas', 'webp', 'gif', 'svg', 'gltf', 'ani', 'bin', "geo", "mgeo", "sklai"
            ],
        obj_suffixs: // 资源对象的后缀
            [
                'png', 'jpg', 'jpeg', 'wav', 'mp3', 'aac', 'webm', 'mp4', 'ogg', 'm3u8', 'ttf', 'TTF', 'otf', 'woff', 'woff2'
            ],

        res_timeout: 10, // 资源的超时时间，单位：秒
        res_cache_size: 512 * 1024, // 每个 资源 缓存的内存大小
    };
    winit.setLoadRes(loadRes);
    //#endregion


    //#region 设置加载流程相关配置
    var loadProcess = {
        /**
         * @TODO 起始加载的分包目录
         */
        load: [
            'pi_utils/',
            'psd/',
        ],
        /**
         * @TODO 加载完毕后执行的模块、方法和参数(注册widget， 初始化gui引擎)
         */
        exec: [
            [
                'pi_utils/main', 'init_pi_utils'
            ]
        ],
        /**
         * @TODO 继续加载的代码模块
         */
        next_load: [
            "cipher/",
            "crypto/",
            "db/",
            "event/",
            "lang/",
            "lodash/",
            "math/",
            "net/",
            "render/",
            "res/",
            "serialization/",
            "util/",
            "jasmine_core/",
            "test_entrance.js"
        ],
        /**
         * @TODO 继续加载完毕后执行的模块、方法和参数
         */
        next_exec: [
            ["test_entrance", "run"]
        ],
        /**
         * @TODO 代码层控制的后续加载
         */
        last_load: [

        ]
    };

    winit.setLoadProcess(loadProcess);
    //#endregion


    // TODO: 尽量 统一 浏览器 和 小游戏的 进度条；比如 背景图

    //#region 设置加载进度条相关配置
    var loadProcessBar = {
        load_bar: // 加载进度条的配置
        {
            text_color: '#fff', // 进度条的文字颜色  仅web&webview适用
            bar_bgcolor: '#4db0b2', // 进度条的背景颜色  仅web&webview适用
            bar_color: '#f1f2f1', // 进度条的颜色     仅web&webview适用
            canvas: window.canvas, // 仅小游戏适用
            /**
             * @TODO 加载界面背景图的项目路径
             */
            bgurl: "pi_sys/ui_1.jpg" // 仅小游戏适用
        },
        load_text: // 起始加载显示的文本
            '',
        next_load_bar: // 继续加载进度条的配置
        {
            text_color: '#fff', // 进度条的文字颜色     仅web&webview适用
            bar_bgcolor: '#4db0b2', // 进度条的背景颜色  仅web&webview适用
            bar_color: '#f1f2f1', // 进度条的颜色      仅web&webview适用
            canvas: window.canvas, // 仅小游戏适用
            /** 
             * @TODO 加载界面背景图的项目路径
             */
            bgurl: "pi_sys/ui_1.jpg" // 仅小游戏适用
        },
        next_load_text: // 继续加载显示的文本
            '',
    }

    winit.setLoadProcessBar(loadProcessBar);
    //#endregion
})();
